CREATE OR REPLACE PACKAGE component as
   PROCEDURE get_msg (recipient IN VARCHAR2, msg OUT VARCHAR2, timeout NUMBER);   
   PROCEDURE update_params_list (param_name IN VARCHAR2, newval IN VARCHAR2, actor IN VARCHAR2);
   PROCEDURE get_params_list (param_name IN VARCHAR2, result OUT VARCHAR);
   PROCEDURE increase_params_list_val (param_name IN VARCHAR2, incVal IN VARCHAR2, actor IN VARCHAR2);
END;
/

CREATE OR REPLACE PACKAGE BODY component as
PROCEDURE get_msg (recipient IN VARCHAR2, msg OUT VARCHAR2, timeout NUMBER) AS
p   AITDB_RULE_ACTIONS%ROWTYPE;
EqueueTime DATE;
priority AITDB_PARAMS_LIST.PRIORITY%TYPE;
DELIM CHAR(1) := ',';
BEGIN
  AITDB_dequeue_params (recipient, p.PName, p.Val, p.Action, priority, EqueueTime, timeout);
  msg := priority || DELIM || p.PName || DELIM || p.Val || DELIM || p.Action || DELIM || EqueueTime;
END;

PROCEDURE get_params_list (param_name IN VARCHAR2, result OUT VARCHAR) IS
BEGIN
   SELECT val INTO result FROM AITDB_PARAMS_LIST WHERE pname = param_name;
END;

PROCEDURE update_params_list (param_name IN VARCHAR2, newval IN VARCHAR2, actor IN VARCHAR2) AS
PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
  UPDATE AITDB_PARAMS_LIST 
  SET VAL = newval,
  upd_by = actor,
  upd_time = SYSDATE
  WHERE pname = param_name;
  COMMIT;
END;

PROCEDURE increase_params_list_val (param_name IN VARCHAR2, incVal IN VARCHAR2, actor IN VARCHAR2) AS
iVal NUMBER;
sVal VARCHAR2(100);
BEGIN
  get_params_list (param_name, sVal);
  sVal := TO_CHAR(TO_NUMBER(sVal) + TO_NUMBER(incVal));
  IF TO_NUMBER(sVal) < 0 THEN
     sVal := '0';
  END IF;
  update_params_list (param_name, sVal, actor);
END;

END;
/

CREATE OR REPLACE PROCEDURE t AS
msg VARCHAR2(100);
BEGIN
--  COMPONENT.get_msg ('MEDIATOR', msg, 3);
-- DBMS_OUTPUT.PUT_LINE ('Msg:'||msg);
-- COMPONENT.update_params_list('TRNS_DELAY', '99', 'MEDIATOR');
--   COMPONENT.increase_params_list_val('TRNS_DELAY', '-1', 'MEDIATOR');
   COMPONENT.update_params_list('TRNS_SUBMS_RATE', '1', 'MEDIATOR');
   COMMIT;
END;
/





 